#*****************************************************
# RPM Wizard
# Copyright 2001, 2002, 2003 Magnus Bjorklof <bjorklof@nic.fi>
# License: GNU General Public License
#*****************************************************

from qt import *

import string, locale
import rpm
import test


class DetailsDialog(QDialog):
    def __init__(self,parent = None,name = None,modal = 1,fl = 0):
        QDialog.__init__(self,parent,name,modal,fl)

        if name == None:
            self.setName('MyDialog1')

        self.resize(383,382)

        self.setSizeGripEnabled(1)

        Layout13 = QVBoxLayout(self)
        Layout13.setSpacing(6)
        Layout13.setMargin(11)

        self.tabWidget = QTabWidget(self,'tabWidget')

	self.MultiLineEdit17 = QTextView(self.tabWidget,'MultiLineEdit17')

	self.tabWidget.insertTab(self.MultiLineEdit17,self.trUtf8('Properties'))

        self.ListView2 = QListView(self.tabWidget,'ListView2')

	self.tabWidget.insertTab(self.ListView2,self.trUtf8('Files'))
        Layout13.addWidget(self.tabWidget)

        Layout12 = QHBoxLayout()
        Layout12.setSpacing(6)
        Layout12.setMargin(0)
        spacer = QSpacerItem(20,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        Layout12.addItem(spacer)

        self.buttonOk = QPushButton(self,'buttonOk')
        self.buttonOk.setText(self.trUtf8('&OK'))
        self.buttonOk.setAutoDefault(1)
        self.buttonOk.setDefault(1)
        Layout12.addWidget(self.buttonOk)
        spacer_2 = QSpacerItem(20,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        Layout12.addItem(spacer_2)

        Layout13.addLayout(Layout12)

        self.connect(self.buttonOk,SIGNAL('clicked()'),self,SLOT('accept()'))


    def setValues(self, desc, files):

	self.MultiLineEdit17.setText(desc)

	self.ListView2.addColumn(QString(self.trUtf8('%1 files')).arg(str(len(files))))

        for f in files:
        	if f==files[0]:

			self.item = QListViewItem(self.ListView2,None)
                        ff=string.strip(f)
			self.item.setText(0, ff)
		else:
			self.item = QListViewItem(self.ListView2,self.item)
                        ff=string.strip(f)
			self.item.setText(0, f)

class GetDetails:
    def __init__(self, header):
    	self.header=header
	
    def get(self, self2):

    	header=self.header

 	files=header[rpm.RPMTAG_FILENAMES]
	name=header[rpm.RPMTAG_NAME]
	summary=header[rpm.RPMTAG_SUMMARY]
	version=header[rpm.RPMTAG_VERSION]
	group=header[rpm.RPMTAG_GROUP]
	size=str(header[rpm.RPMTAG_SIZE])
	distribution=header[rpm.RPMTAG_DISTRIBUTION]
	vendor=header[rpm.RPMTAG_VENDOR]
	packager_=header[rpm.RPMTAG_PACKAGER]
	provides_=header[rpm.RPMTAG_PROVIDES]
	(unsatisfied, conflicts, iii, ooo)=test.depCheck(self, self.header, databases='', details_dialog=1)


	def correct(item):
		item=string.replace(item, '<', '&#60;')
		item=string.replace(item, '>', '&#62;')
		return item

	if packager_!=None:
		packager=correct(packager_)
	else:
		packager=None



	reqflags=header[rpm.RPMTAG_REQUIREFLAGS]
	reqnames=header[rpm.RPMTAG_REQUIRENAME]
	reqversions=header[rpm.RPMTAG_REQUIREVERSION]
	g=0
	depends=None
	if reqnames!=None:
	    try:
		len(reqflags)
	    except:
	    	reqflags=[reqflags]
	    for reqq in reqnames:
		req=test.makeRequireString(reqq, reqversions[g], reqflags[g])
		if depends==None:
			depends=req
		else:
                	depends=depends+', '+req
		g=g+1
	    depends=correct(depends)


	provides=None
	if provides_!=None:
            for p in provides_:
        	if provides==None:
			provides=string.strip(p)
		else:
                	provides=provides+', '+string.strip(p)


	TrName=QString(self2.trUtf8('Name:'))
	TrSummary=QString(self2.trUtf8('Summary:'))
	TrVersion=QString(self2.trUtf8('Version:'))
	TrGroup=QString(self2.trUtf8('Group:'))
	TrSize=QString(self2.trUtf8('Size:'))
	TrUnsat=QString(self2.trUtf8('Unsatisfied dependencies:'))
	TrDepends=QString(self2.trUtf8('Depends:'))
	TrProvides=QString(self2.trUtf8('Provides:'))
	TrDistribution=QString(self2.trUtf8('Distribution:'))
	TrVendor=QString(self2.trUtf8('Vendor:'))
	TrPackager=QString(self2.trUtf8('Packager:'))




	desc=QString.fromLocal8Bit("<table>")

	desc.append("<tr><td><b>")
	desc.append(TrName)
	desc.append("</b></td><td>")
	desc.append(QString.fromLocal8Bit(name))
	desc.append("</td></tr><tr><td><b>")
	desc.append(TrSummary)
	desc.append("</b></td><td>")
	desc.append(QString.fromLocal8Bit(summary))
	desc.append("</td></tr><tr><td><b>")
	desc.append(TrVersion)
	desc.append("</b></td><td>")
	desc.append(QString.fromLocal8Bit(version))
	desc.append("</td></tr><tr><td><b>")
	desc.append(TrGroup)
	desc.append("</b></td><td>")
	desc.append(QString.fromLocal8Bit(group))
	desc.append("</td></tr><tr><td><b>")
	desc.append(TrSize)
	desc.append("</b></td><td>")
	desc.append(QString.fromLocal8Bit(size))
	desc.append("</td></tr>")
	if unsatisfied!=None and unsatisfied!='':
		desc.append("<tr><td><b>")
                desc.append(TrUnsat)
		desc.append("</b></td><td>")
                desc.append(QString.fromLocal8Bit(unsatisfied))
                desc.append("</td></tr>")
	if depends!=None:
        	desc.append("<tr><td><b>")
                desc.append(TrDepends)
		desc.append("</b></td><td>")
                desc.append(QString.fromLocal8Bit(depends))
                desc.append("</td></tr>")
	if provides!=None:
		desc.append("<tr><td><b>")
                desc.append(TrProvides)
                desc.append("</b></td><td>")
		desc.append(QString.fromLocal8Bit(provides))
                desc.append("</td></tr>")

 	if distribution!=None:
		desc.append("<tr><td><b>")
                desc.append(TrDistribution)
		desc.append("</b></td><td>")
                desc.append(QString.fromLocal8Bit(distribution))
                desc.append("</td></tr>")
        if vendor!=None:
                desc.append("<tr><td><b>")
                desc.append(TrVendor)
		desc.append("</b></td><td>")
                desc.append(QString.fromLocal8Bit(vendor))
                desc.append("</td></tr>")
        if packager!=None:
		desc.append("<tr><td><b>")
                desc.append(TrPackager)
                desc.append("</b></td><td>")
                desc.append(QString.fromLocal8Bit(packager))
                desc.append("</td></tr>")
	desc.append("</table>")

	return desc, files
