#*****************************************************
# RPM Wizard
# Copyright 2002, 2003 Magnus Bjorklof <bjorklof@nic.fi>
# License: GNU General Public License
#*****************************************************

import re
import commands
import os
import fnmatch
import string
import sys
import rpm

from qt import *
from conf import *





class InstallFromList:
    def __init__(self, pageList, self2):

    	self.pageList=pageList
	self.current=-1
	self.image1 = QPixmap(APPDIR + './rpmwiz_mini.png')
	self.namelist=[]

	self.previousNrOfUnselectedChar=0
	self.currentChangedByMouse=0

	self.hasSelectedText=0

	self.self2=self2
    def textChange(self, text):

	text=str(text)
	self.self2.setNextEnabled(self.self2.pageList, 1)
	self.self2.nextButton().setEnabled(1)

	
	if self.currentChangedByMouse==1:
		self.currentChangedByMouse=0
		return
	else:
		pass


	if self.hasSelectedText==1:
		self.hasSelectedText=0
		return
	else:
		pass


	if len(text)<=self.previousNrOfUnselectedChar: # we have deleted some character in the line edit
		# next should be disabled at this stage and reenabled when select something again
		self.previousNrOfUnselectedChar=len(text)
		self.pageList.ListBox.setSelected(self.current,0) 

		self.self2.setNextEnabled(self.self2.pageList, 0)
		self.self2.nextButton().setEnabled(0)



		if text=='':
			self.pageList.ListBox.setTopItem(0)

		else:
		    j=-1
		    text=string.lower(text)

		    for item in self.namelist:
			j=j+1
			i=-1
			item=item[0]
			item=string.lower(item)
			for char in text:
				i=i+1
				if char==item[i]:
					pass
				else:
					break
			else:

				self.pageList.ListBox.setCurrentItem(j)
				self.pageList.ListBox.setSelected(j,0)
				self.pageList.ListBox.ensureCurrentVisible()
				break

		return
	else:
		self.previousNrOfUnselectedChar=len(text)


    	foundItem=self.pageList.ListBox.findItem(text)

	if foundItem!=None:

		self.pageList.ListBox.setCurrentItem(foundItem)

		self.current=self.pageList.ListBox.currentItem()

		self.pageList.ListBox.ensureCurrentVisible()

		self.setLineEditSelection()
		# ensure that the current item is selected
		# it is not when we have deleted and then writing text so that the same item is current
		self.pageList.ListBox.setSelected(self.current,1)

	else:
		self.pageList.ListBox.setSelected(self.current,0)

		# next button should be disabled
		self.self2.setNextEnabled(self.self2.pageList, 0)
		self.self2.backButton().setEnabled(1)



    def setLineEditSelection(self):
    	"""sets the selection in the line edit so that the text that the user has written is not selected"""


    	lineEditText=str(self.pageList.LineEdit31.text())
	itemText=str(self.pageList.ListBox.currentText())

	if string.find(itemText, lineEditText)==-1:
		
		return
	else:
		pass





	list=string.split(itemText, lineEditText,1)

	where=string.find(itemText,list[1])

	if where==-1:
		print "error"

	self.hasSelectedText=1

	self.pageList.LineEdit31.setText(itemText)


	self.pageList.LineEdit31.setSelection(where, len(list[1]))
	


    def currentListItemSet(self, item):
	"""slot that receives the clicked signal from the list box"""


	self.currentChangedByMouse=1
	self.previousNrOfUnselectedChar=0
	
	try: # this is a workaround for a strange bug (Qt bug?)
		# it seems that Qt sometimes sends a signal when clicked on the side of
		# the list box and the item it sends is None
		self.pageList.LineEdit31.setText(item.text())
		self.pageList.LineEdit31.selectAll()
	except AttributeError:
		pass




    def createlist(self):
		filelist=[]
		try:
			filelist=os.listdir(DATABASEDIR)

		except OSError:
    			print "Could not find database"

		rpmdatabaselist=[]
		for f in filelist:
			if fnmatch.fnmatch(f, 'list.*')==1:
				rpmdatabaselist.append(f)




		namelist=[]

		for dbfile in rpmdatabaselist:
			try:
				fd=open(DATABASEDIR+'/'+dbfile)
				rpmfileslist=fd.readlines()
				fd.close()
			except:
				print "Could not open", dbfile
				continue


			for i in rpmfileslist:
				f=string.split(i, ':')
				basename=os.path.basename(f[1])
				basename=string.strip(basename)
				namelist.append(basename)

		
		namelist4=[]
		rpmdb = rpm.opendb()

		for text in namelist:
			list=re.split('\.rpm', text)
			if len(list)>2:
				print "not good..."
				list=list[0]


			list=string.split(list[0], '-')

			
			release=list[len(list)-1]

			release=string.split(release, '.')
			release2=''
			c=len(release)
			t=0
			for r in release:
				if t!=(c-1):
					if release2!='':
						release2=release2+'.'+r
					else:
						release2=r


				t=t+1
			
			release=release2

			if len(list)>2:



				list=list[:(len(list)-1)]
				version=list[len(list)-1]
				list=list[:(len(list)-1)]

				name=''
				for i in list:
					if name=='':
						name=i
					else:
						name=name+'-'+i
			elif len(list)==2:
				print "Nooooo...",list
				name=list[0]
				version=list[1]
			else:
				print "nooooooo...", list
				name=list[0]
				version=''


			
			indexes = rpmdb.findbyname(name)
			if indexes==[]:
				namelist4.append([name+' '+version, text])
			else:
		    	    for index in indexes:
				header = rpmdb[index]
				if str(header[rpm.RPMTAG_VERSION])==str(version) and release==str(header[rpm.RPMTAG_RELEASE]):
					# the package is already installed

					break
				elif self.isNewer(str(version), release, str(header[rpm.RPMTAG_VERSION]), str(header[rpm.RPMTAG_RELEASE]))==0:
					# version is not newer than the installed one
					# and we should not list it

					break
				else:
					pass


			    else:
				namelist4.append([name+' '+version, text])


		# namelist4=['name 1.0', 'name-1.0-1.rpm']


		# This is an algorithm to make the list alphabethical
		# in non-old-school-Unix form (A==a)

		namelist2=[]

		i=0
		for name in namelist4:
			namelist2.append([string.lower(name[0]), i, name[1]])

			i=i+1

		namelist2.sort()

		# namelist2=['name 1.0', 3434, 'name-1.0-1.rpm']

		namelist3=[]
		for item in namelist2:
			namelist3.append(namelist4[item[1]])


		for item in namelist3:

			self.pageList.ListBox.insertItem(self.image1,item[0])


		self.namelist=namelist3

		

    def isNewer(self, notInstalled, notInstalledRelease, installed, installedRelease):
	"""Compare two version strings and return 1 if notInstalled is newer, otherwise 0"""


	if installed==notInstalled: # versions are equal, we check the releases

		if self.isNewerVersion(notInstalledRelease, installedRelease)==1:

			return 1
		else:
			
			return 0

	if self.isNewerVersion(notInstalled, installed)==1:
		return 1
	else:
		return 0
			

    def isNewerVersion(self, release1, release2):
    	"return 1 if release1 is newer"

    	t=0

	listOne=string.split(release1, '.')
	listTwo=string.split(release2, '.')

	t=0
	for i in listOne:
		try:
			listTwo[t]
		except:
			i=listOne[len(listTwo)]
			i=i[0]
			if i=='0' or i=='1' or i=='2' or i=='3' or i=='4' or i=='5' or i=='6' or i=='7' or i=='8' or i=='9':
				return 0

		o=self.versionTest(i, listTwo[t])

		if o==0 or o==1:
			return o
		else:
			pass
		t=t+1
	if len(listOne)<len(listTwo):
		i=listTwo[len(listOne)]
		i=i[0]
		if i=='0' or i=='1' or i=='2' or i=='3' or i=='4' or i=='5' or i=='6' or i=='7' or i=='8' or i=='9':
			return 0
	else:
		# we can't know which one is newer so we just return 1
		return 1

    def versionTest(self, release1, release2):
    	"""A test of the version used in isNewerVersion"""
    	if release1==release2:
		return 2
	if release1=='' or release2=='':
		return 1

	nr1='0'
	nr2='0'
	for i in str(release1):
		if i=='0' or i=='1' or i=='2' or i=='3' or i=='4' or i=='5' or i=='6' or i=='7' or i=='8' or i=='9':
			nr1=nr1+i
		else:
			break
	for i in str(release2):
		if i=='0' or i=='1' or i=='2' or i=='3' or i=='4' or i=='5' or i=='6' or i=='7' or i=='8' or i=='9':
			nr2=nr2+i
		else:
			break
	
	if int(nr1)>int(nr2):
		return 1
	elif int(nr2)>int(nr1):
		return 0
	else:
		return 2

    def selected(self):

	current=self.pageList.ListBox.currentItem()
	if current==-1:
		# no selected item
		return -1
	else:
		basename=self.namelist[current][1]


		filelist=[]
    		try:
    			filelist=os.listdir(DATABASEDIR)
    		except OSError:
    			print "Could not find database"

    		rpmdatabaselist=[]
    		for f in filelist:
			if fnmatch.fnmatch(f, 'list.*')==1:
				rpmdatabaselist.append(f)

		rpmfilestuple=[]
    		for dbfile in rpmdatabaselist:
			try:
				fd=open(DATABASEDIR+'/'+dbfile)
				rpmfileslist=fd.readlines()
				fd.close()
			except:
				print "Could not open", dbfile
				continue

			for filerow in rpmfileslist:
				rpmfilestuple.append((filerow, dbfile[5:]))


		for (row,sname) in rpmfilestuple:
			r=string.split(row, ':/')
			filename=r[1]

			if fnmatch.fnmatch(filename, '*'+basename)==1:
				return (string.strip(filename), sname)

		else:
			print "error"
			return -1
    def hasDatabase(self):

    	(st, out)=commands.getstatusoutput('ls '+DATABASEDIR+'list.*')

	if st==0:
		return 1
	else:
		return 0

