#!/usr/bin/env python

#***********************************************************************
# RPM Wizard
# Copyright 2001, 2002, 2003 Magnus Bjorklof <bjorklof@nic.fi>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.
# If not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#***********************************************************************


import sys, locale
import string

from test import *
from conf import *
from qt import *
from main import *

fileName=''


if __name__ == '__main__':

    argg=1
    try:
       	sys.argv[1]
    except IndexError:
	argg=0


    if argg==1:
	if sys.argv[1][0]=='-':
		fileName = cltest()
	else:
		fileName=sys.argv[1]
    else:
    	pass
	
    isRoot=userTest()

    a = QApplication(sys.argv)

    lang, enc=locale.getlocale()
    
    
    # check version of Qt
    translate=1
    qtMajor = int(qVersion().split('.')[0])
    if qtMajor < 3:
        print 'Qt version < 3.0.0. No translations used.'
        translate=0

    #check version of PyQt
    if PYQT_VERSION[:9] == "snapshot-":
        if long(PYQT_VERSION[9:]) < 20020812L:
            print 'PyQt version < snapshot 20020812. No translations used.'
            translate=0
    else:
        while PYQT_VERSION.count('.') < 2:
            PYQT_VERSION += '.0'
        (maj, min, pat) = PYQT_VERSION.split('.')
        maj = int(maj)
        min = int(min)
        pat = int(pat)
        if maj < 3 or (maj == 3 and min < 4):
            print 'PyQt version < 3.4. No translations used.'
	    print 'Please upgrade to a newer version of PyQt if you want to use translations.'
	    translate=0

    if translate==1:
    	loaded = 0

    	translator = QTranslator(None)

    	loaded = translator.load("rpmwiz_" + lang, APPDIR)

    	if loaded:
        	a.installTranslator(translator)
    	else:
        	print "No '" + lang + "' translations for RPM Wizard found."
        	print "Please contact Magnus Bjorklof "+EMAIL+" if you want to contribute a translation for your language."


    if isRoot==0:
        print "You have to be root to run this app."
	qmb=QMessageBox(NAME, 'Sorry, you have to be root to run this app.',QMessageBox.Information,QMessageBox.Ok|QMessageBox.Default, 0, 0)
	qmb.exec_loop()
	sys.exit(0)
    else:
        pass

    w = RpmWiz()
    a.setMainWidget(w)

    if fileName!='' and fileName!='%f': # that later is a workaround for a bug in Nautilus
    	w.startAtPage2(fileName)
    else:
    	pass

    w.show()
    a.exec_loop()
