#*****************************************************
# RPM Wizard
# Copyright 2002, 2003 Magnus Bjorklof <bjorklof@nic.fi>
# License: GNU General Public License
#*****************************************************

from qt import *
from conf import *


class WizardPage(QWidget):
    """This is the base class from which the wizard pages will inherit"""
    def __init__(self, parent, name, verticalItems=4):
	QWidget.__init__(self, parent, name)

	self.image=Image(self, APPDIR)


	self.layout = QGridLayout(self)
        self.layout.setSpacing(6)
        self.layout.setMargin(6)


	
	self.layout.addMultiCellWidget(self.image,0,verticalItems-1,0,0)


	# --------- White Header ------------


	self.WhiteHeader = QLabel(self,'self.WhiteHeader')

        self.WhiteHeader.setSizePolicy(QSizePolicy(5,1,self.WhiteHeader.sizePolicy().hasHeightForWidth()))
        pal = QPalette()
        cg = QColorGroup()
        cg.setColor(QColorGroup.Foreground,Qt.black)
        cg.setColor(QColorGroup.Light,Qt.white)
        cg.setColor(QColorGroup.Text,Qt.black)
        cg.setColor(QColorGroup.BrightText,Qt.white)
        cg.setColor(QColorGroup.ButtonText,Qt.black)
        cg.setColor(QColorGroup.Base,Qt.white)
        cg.setColor(QColorGroup.Background,Qt.white)
        cg.setColor(QColorGroup.Shadow,Qt.black)
        cg.setColor(QColorGroup.HighlightedText,Qt.white)
        pal.setActive(cg)
	cg = QColorGroup()
        cg.setColor(QColorGroup.Foreground,Qt.black)
        cg.setColor(QColorGroup.Light,Qt.white)
        cg.setColor(QColorGroup.Text,Qt.black)
        cg.setColor(QColorGroup.BrightText,Qt.white)
        cg.setColor(QColorGroup.ButtonText,Qt.black)
        cg.setColor(QColorGroup.Base,Qt.white)
        cg.setColor(QColorGroup.Background,Qt.white)
        cg.setColor(QColorGroup.Shadow,Qt.black)
        cg.setColor(QColorGroup.HighlightedText,Qt.white)
        pal.setInactive(cg)

        self.WhiteHeader.setPalette(pal)
        self.WhiteHeader_font = QFont(self.WhiteHeader.font())
        self.WhiteHeader_font.setPointSize(14)
        self.WhiteHeader_font.setBold(1)
        self.WhiteHeader.setFont(self.WhiteHeader_font)
        self.WhiteHeader.setFrameShape(QLabel.StyledPanel)
        self.WhiteHeader.setFrameShadow(QLabel.Sunken)
        self.WhiteHeader.setMargin(4)
        self.WhiteHeader.hide() # it's hidden by default

	# --------- White Header Ends ------------

class Image(QLabel):
    def __init__(self, widget, APPDIR):
    	"""Sets the image of the wizard."""
	QLabel.__init__(self,widget,'PixmapLabel1')

	self.image0 = QPixmap(APPDIR + './imagerpm.png')

        self.setPixmap(self.image0)
        self.setScaledContents(0)
        self.setFrameShape(QLabel.StyledPanel)
        self.setFrameShadow(QLabel.Sunken)
        self.setIndent(0)
	self.setSizePolicy(QSizePolicy(0,0,self.sizePolicy().hasHeightForWidth()))


